NASM=nasm.exe
#LIBPATH="C:\Program Files (x86)\Windows Kits\10\Lib\10.0.18362.0\um\x64"
#KERNEL32=$(LIBPATH)\kernel32.lib
#USER32=$(LIBPATH)\user32.lib
#LINK="C:\Program Files (x86)\Microsoft Visual Studio\2019\Enterprise\VC\Tools\MSVC\14.29.30037\bin\Hostx64\x86\link.exe"
#LINKOPT=/ENTRY:WinMain /SUBSYSTEM:WINDOWS $(KERNEL32) $(USER32) /OUT:$@
LINK=gcc.exe
# use '-nostartfiles -Wl,--entry=mymain' for another entry point
LINKOPT=-mwindows -lkernel32 -luser32 -o $@

all: messagebox.exe test_register_dump.exe

messagebox.obj: messagebox.asm
	$(NASM) -fwin64 $^ -o $@

messagebox.exe: messagebox.obj
	$(LINK) $(LINKOPT) $^

register_dump.obj: register_dump.asm
	$(NASM) -fwin64 $^ -o $@

test_register_dump.obj: test_register_dump.asm
	$(NASM) -fwin64 $^ -o $@

test_register_dump.exe: register_dump.obj test_register_dump.obj
	$(LINK) $(LINKOPT) $^


.PHONY: clean
clean:
	-rm messagebox.exe
	-rm messagebox.obj
	-rm test_register_dump.exe
	-rm test_register_dump.obj
	-rm register_dump.obj
